//  n2epsilon
//
// Copyright 2001 by Markus Leitz
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public License
// version 2 as published by the Free Software Foundation.//
// This library is distributed  WITHOUT ANY WARRANTY;
// without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.


#include "n2epsilon.h"
#include <FL/math.h>
#include <Fl/fl_message.H>
#include "HelpDialog.h"
complex <double> N2EPSILON::set(double a,double b)
{ 
  complex <double> z(a,b);
  return z;
}


void N2EPSILON::init(void)
{
  n = set(1.0,0.0);
  n2epsilon();
 
  lambda = 632.8;
  UI_lambda->value(lambda);
  calc_K();  


}

void N2EPSILON::show(void)
{
  UI_mainWindow->show();

}


void N2EPSILON::epsilon2n(void)
{
  n = sqrt(epsilon);
  
 
  UI_n_real->value( n.real() );
  UI_n_imag->value( n.imag() ); 
  calc_K();
  UI_mainWindow->redraw();
}

void N2EPSILON::n2epsilon(void)
{
 epsilon = n*n;
  
 UI_epsilon_real->value( epsilon.real() );
 UI_epsilon_imag->value( epsilon.imag() ); 
 calc_K();
 UI_mainWindow->redraw();
}

void N2EPSILON::calc_K(void)
{
  
  K = (2*M_PI/(lambda *1e-9))* n.imag();
  
  UI_K->value(K) ;

  

}


void N2EPSILON::about_dialog(void)
{
  fl_message("n2epsilon -  written by Markus Leitz with the help of the excellent   fltk toolkit (www.fltk.org)");
}


void N2EPSILON::help_dialog(void)
{
  HelpDialog *MyHelpDialog = new HelpDialog();
  MyHelpDialog->load("n2epsilon.html");
  MyHelpDialog->show();
}











